Attribute VB_Name = "dllINI071"
' the plugin<->INI module
' copyright 2004-2009 Erik Siers

' screw this; each plugin saves its own data, with a recommendation that it saves to EEShell2.ini


FUNCTION pWriteINI(plugin AS STRING, key AS STRING, info AS STRING) AS LONG
    ' writes Plugin data to EEShell2.ini

    ' args:
    ' plugin    the calling plugin
    ' key       what keyname to write
    ' info      what to write to key

    ON ERROR RESUME NEXT

    DIM d AS LONG
    DIM p AS STRING * MAX_PATH, k AS STRING * MAX_PATH, i AS STRING * MAX_PATH

    p = plugin
    k = key
    i = info

    d = WritePrivateProfileString(p, k, i, "EEShell2.ini")

    pWriteINI = ERR
    Err.Clear
END FUNCTION


FUNCTION pReadINI(plugin AS STRING, key AS STRING, info AS STRING) AS LONG
    ' reads Plugin data from EEShell2.ini

    ' args:
    ' plugin    the calling plugin
    ' key       what keyname to write
    ' info      what to write to key

    ON ERROR RESUME NEXT

    DIM d AS LONG
    DIM p AS STRING * MAX_PATH, k AS STRING * MAX_PATH, i AS STRING * MAX_PATH

    p = plugin
    k = key

    d = GetPrivateProfileString(p, k, "", i, MAX_PATH, "EEShell2.ini")

    info = i
    pReadINI = ERR
    Err.Clear
END FUNCTION
