VERSION 5.00
Begin VB.Form frmBG071
   ClientHeight    =   3030
   ClientLeft      =   60
   ClientTop       =   510
   ClientWidth     =   4680
   ScaleHeight     =   3030
   ScaleWidth      =   4680
   Begin VB.CommandButton cmdPlugin
      Caption         =   "Plugins"
      Enabled         =   0   'False
      Height          =   255
      Index           =   0
      Left            =   1080
      TabIndex        =   0
      ToolTipText     =   "Run an application or document"
      Top             =   2160
      Visible         =   0   'False
      Width           =   1575
   End
End
Attribute VB_Name = "frmBG071"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' the main form for EEShell2

' copyright 2004-2009 Erik Siers
' source code provided under terms of version 2 of the GNU GPL

' this is the background of the shell
' it will allow the windows background to show through (briefly) once in a while
' notably when doing a manual refresh
' I don't much care so I haven't tried to fix it

Option Explicit

' these are used when dragging the buttons around
Private bDown As Long, bLeft As Single, bTop As Single


Private Sub Form_Unload(Cancel As Integer)
    unloadPlugins
End Sub


Public Sub addPluginButtons()
    ' places plugin buttons on frmBG
    ' plugins must already have been loaded via findPlugins()

    If pCount > 0 Then
        Dim x As Long, n As Long, i As String
        For x = 1 To pCount
            Load cmdPlugin(x)
            With cmdPlugin(x)
                .Caption = Plugins(x).pName

                n = pReadINI(Plugins(x).pName, "btnLeft", i)
                If Len(i) Then
                    .Left = Val(i)
                Else
                    .Left = frmBG.Width - .Width
                End If
                n = pReadINI(Plugins(x).pName, "btnTop", i)
                If Len(i) Then
                    .Top = Val(i)
                Else
                    .Top = .Height * (x - 1)
                End If

                .TabIndex = x + 5
                .Visible = True
                .Enabled = True
            End With
        Next
    End If
End Sub

Private Sub cmdPlugin_Click(Index As Integer)
    On Error Resume Next

    If Index <> 0 Then  ' cmdPlugin(0) shouldn't even be visible!
        ' this is how the plugin knows to do its dirty deeds
        Plugins(Index).pObj.Show Me.hWnd
    End If
End Sub

Private Sub cmdPlugin_MouseDown(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If (2 = Button) And Not lockButtons Then bDown = Index: bLeft = x: bTop = y
End Sub

Private Sub cmdPlugin_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If bDown <> 0 Then
        With cmdPlugin(bDown)
            .Left = .Left + x - bLeft
            .Top = .Top + y - bTop
        End With
    End If
End Sub

Private Sub cmdPlugin_MouseUp(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim n As Long

    bDown = 0
    n = pWriteINI(Plugins(Index).pName, "btnLeft", cmdPlugin(Index).Left)
    n = pWriteINI(Plugins(Index).pName, "btnTop", cmdPlugin(Index).Top)
End Sub
