' API declaration for EEShell2.dll.
' The standard Win32API.inc will also work but will increase the final .dll size.
' required by:
'   EEShell2.bas
'   Run.bi
'   Shell.bi
'   Shutdown.bi
'   Startup.bi


%CSIDL_STARTUP        =  7  ' %USERPROFILE%\Start Menu\Programs\Startup
%CSIDL_COMMON_STARTUP = 24  ' All USers\Start Menu\Programs\Startup

%DLL_PROCESS_DETACH = 0
%DLL_PROCESS_ATTACH = 1

%MB_ICONWARNING = &H00000030&
%MB_ICONERROR = &H00000010&
%MB_TASKMODAL = &H00002000&

%BIF_RETURNONLYFSDIRS = &H0001  ' For finding a folder to start document searching
%ERROR_SUCCESS = 0
%FILE_ATTRIBUTE_DIRECTORY = &H00000010
%FORMAT_MESSAGE_FROM_SYSTEM = &H1000
%MAX_PATH = 260                 ' max. length of full pathname
%REG_SZ = 1                     ' Unicode nul terminated string
%SE_PRIVILEGE_ENABLED = &H00000002
%TOKEN_QUERY = &H0008
%TOKEN_ADJUST_PRIVILEGES = &H0020
%VER_PLATFORM_WIN32_NT = 2

%HKEY_CURRENT_USER = &H80000001???
%HKEY_LOCAL_MACHINE = &H80000002???

%KEY_QUERY_VALUE = &H1
%KEY_SET_VALUE = &H2
%KEY_CREATE_SUB_KEY = &H4
%KEY_ENUMERATE_SUB_KEYS = &H8
%KEY_NOTIFY = &H10
%KEY_CREATE_LINK = &H20
%SYNCHRONIZE = &H00100000
%STANDARD_RIGHTS_ALL = &H001F0000
%KEY_ALL_ACCESS = %STANDARD_RIGHTS_ALL OR %KEY_QUERY_VALUE OR %KEY_SET_VALUE OR %KEY_CREATE_SUB_KEY OR _
                  %KEY_ENUMERATE_SUB_KEYS OR %KEY_NOTIFY OR %KEY_CREATE_LINK AND (NOT %SYNCHRONIZE)

TYPE BROWSEINFO
    hWndOwner AS DWORD
    pIDLRoot AS DWORD
    pszDisplayName AS ASCIIZ PTR
    lpszTitle AS ASCIIZ PTR
    ulFlags AS DWORD
    lpfnCallback AS DWORD
    lParam AS LONG
    iImage AS LONG
END TYPE

TYPE LUID
    LowPart AS DWORD
    HighPart AS LONG
END TYPE

TYPE LUID_AND_ATTRIBUTES
    pLuid AS LUID
    Attributes AS DWORD
END TYPE

TYPE OSVERSIONINFO
    dwOSVersionInfoSize AS DWORD
    dwMajorVersion AS DWORD
    dwMinorVersion AS DWORD
    dwBuildNumber AS DWORD
    dwPlatformId AS DWORD
    szCSDVersion AS ASCIIZ * 128  ' Maintenance string for PSS usage
END TYPE

TYPE TOKEN_PRIVILEGES
    PrivilegeCount AS DWORD
    Privileges(0 TO 0) AS LUID_AND_ATTRIBUTES  ' array size may vary
END TYPE

DECLARE FUNCTION AdjustTokenPrivileges LIB "ADVAPI32.DLL" ALIAS "AdjustTokenPrivileges" (BYVAL TokenHandle AS DWORD, _
        BYVAL DisableAllPrivileges AS LONG, NewState AS ANY, BYVAL BufferLength AS DWORD, PreviousState AS ANY, _
        ReturnLength AS DWORD) AS LONG
DECLARE FUNCTION LookupPrivilegeValue LIB "ADVAPI32.DLL" ALIAS "LookupPrivilegeValueA" (lpSystemName AS ASCIIZ, _
        lpName AS ASCIIZ, lpLuid AS LUID) AS LONG
DECLARE FUNCTION OpenProcessToken LIB "ADVAPI32.DLL" ALIAS "OpenProcessToken" (BYVAL ProcessHandle AS DWORD, _
        BYVAL DesiredAccess AS DWORD, TokenHandle AS DWORD) AS LONG
DECLARE FUNCTION RegCloseKey LIB "ADVAPI32.DLL" ALIAS "RegCloseKey" (BYVAL hKey AS DWORD) AS LONG
DECLARE FUNCTION RegOpenKeyEx LIB "ADVAPI32.DLL" ALIAS "RegOpenKeyExA" (BYVAL hKey AS DWORD, lpSubKey AS ASCIIZ, _
        BYVAL ulOptions AS DWORD, BYVAL samDesired AS DWORD, phkResult AS DWORD) AS LONG
DECLARE FUNCTION RegQueryValueEx LIB "ADVAPI32.DLL" ALIAS "RegQueryValueExA" (BYVAL hKey AS DWORD, lpValueName AS ASCIIZ, _
        BYVAL lpReserved AS LONG, lpType AS LONG, lpData AS ANY, lpcbData AS LONG) AS LONG
DECLARE FUNCTION RegSetValueEx LIB "ADVAPI32.DLL" ALIAS "RegSetValueExA" (BYVAL hKey AS DWORD, lpValueName AS ASCIIZ, _
        BYVAL dwReserved AS DWORD, BYVAL dwType AS DWORD, lpData AS ANY, BYVAL cbData AS DWORD) AS LONG

DECLARE FUNCTION ExpandEnvironmentStrings LIB "KERNEL32.DLL" ALIAS "ExpandEnvironmentStringsA" (lpSrc AS ASCIIZ, _
        lpDst AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION FormatMessage LIB "KERNEL32.DLL" ALIAS "FormatMessageA" (BYVAL dwFlags AS DWORD, lpSource AS ANY, _
        BYVAL dwMessageId AS DWORD, BYVAL dwLanguageId AS DWORD, lpBuffer AS ASCIIZ, BYVAL nSize AS DWORD, _
        Arguments AS ANY) AS DWORD
DECLARE FUNCTION GetCurrentProcess LIB "KERNEL32.DLL" ALIAS "GetCurrentProcess" () AS LONG
DECLARE FUNCTION GetPrivateProfileString LIB "KERNEL32.DLL" ALIAS "GetPrivateProfileStringA" (lpApplicationName AS ASCIIZ, _
        lpKeyName AS ASCIIZ, lpDefault AS ASCIIZ, lpReturnedString AS ASCIIZ, BYVAL nSize AS DWORD, lpFileName AS ASCIIZ) _
        AS DWORD
DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" (lpVersionInformation AS ANY) AS LONG
DECLARE FUNCTION WritePrivateProfileString LIB "KERNEL32.DLL" ALIAS "WritePrivateProfileStringA" ( _
        lpApplicationName AS ASCIIZ, lpKeyName AS ASCIIZ, lpString AS ASCIIZ, lpFileName AS ASCIIZ) AS LONG

DECLARE FUNCTION SHBrowseForFolder LIB "SHELL32.DLL" ALIAS "SHBrowseForFolderA" (lpbi AS BROWSEINFO) AS DWORD
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, _
        lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD
DECLARE FUNCTION SHGetPathFromIDList LIB "SHELL32.DLL" ALIAS "SHGetPathFromIDListA" (pidList AS ANY, lpBuffer AS ASCIIZ) _
        AS LONG
DECLARE FUNCTION SHGetSpecialFolderPath LIB "SHELL32.DLL" ALIAS "SHGetSpecialFolderPathA" ( _
        BYVAL hwndowner AS DWORD, lpszPath AS ASCIIZ, BYVAL nFolder AS LONG, BYVAL fCreate AS LONG) AS LONG

DECLARE FUNCTION ExitWindowsEx LIB "USER32.DLL" ALIAS "ExitWindowsEx" (BYVAL uFlags AS DWORD, BYVAL dwReserved AS DWORD) _
        AS LONG
