Attribute VB_Name = "modRun"
' Copyright 2004-2010 Erik Siers
' Provided under terms of the GNU GPL; see the file COPYING.TXT for details.

' the run module for EEShell2
' requires:
'   modAPI
' required by:
'   modBG

Option Explicit


Public Sub ShowRunDialog()
    ' displays the standard Windows Run dialog
    ' calls:
    '   IsWinNT     (modAPI->EEShell.dll->EEShell.bas)
    '   SHRunDialog (modINI)
    ' called by:
    '   frmBg.cmdRun_Click

    ' can be disabled in options (uncheck "Use standard Windows "run" dialog")
    Dim sDescription As String
    sDescription = "Enter a program or document to open"
    If IsWinNT Then
        SHRunDialog GetActiveWindow, 0, 0, StrConv("Run...", vbUnicode), StrConv(sDescription, vbUnicode), 0
    Else
        SHRunDialog GetActiveWindow, 0, 0, "Run...", sDescription, 0
    End If
End Sub
